<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>PythonCAD File Format</title>
<link href="stylesheets/pythoncad.css" rel="stylesheet" type="text/css" media="screen" />
</head>
<body>
<div id="header">
<div id="main_logo"><a href="index.html" title="PythonCAD Home"><img src="images/main_logo.png" alt="PythonCAD" /></a></div>
</div><!-- header -->
<div id="main_content">
<h2>PythonCAD File Format Information</h2>
<p>
PythonCAD uses <a href="http://www.w3.org/TR/2000/REC-xml-20001006">XML</a>
for storing files. As text files can get rather large, the files are
compressed with the zlib module when they are being saved. This is the
default behavior now, and there is no way to toggle on or off the
compression. If such functionality is eventually called for, then the
code will be changed to allow saving in uncompressed text. For now, though,
the files are compressed.
</p>
<p>
Using XML for the file format has provides several advantages over creating
a new format. A short summary of reasons why XML was chosen is given below.
</p>
<dl>
<dt><strong>Open Standard</strong></dt>
<dd>
As the XML format is being maintained by
<a href="http://www.w3.org">W3C</a>, it is open and available to anyone.
The open nature of the format means everyone has access to the basic
information giving the file format description.
</dd>
<dt><strong>Python Support</strong></dt>
<dd>
Python ships with a standard module for dealing with XML files, so
there was no need to create a new module to deal with the file. Additionally,
as the module comes with Python, it has the benefits of being used by
many other people and projects, and this wide usage will tend to identify
and repair bugs more quickly than a single use module.
</dd>
<dt><strong>Validation</strong></dt>
<dd>
With the use of either a DTD or a
<a href="http://www.w3.org/TR/xmlschema-0/">Schema</a>, the layout of the file
as well as the data the file is storing can be validated. This validation step
can serve as both a check on the code to ensure that the data is being
written out in the correct form, as well as ensure that all the needed
bits of data are being saved. There are plans to create a Schema for the
PythonCAD file format, as the Schema approach is able to define the
format much more precisely than a DTD can. Currently there is no Schema
available for checking the file, as the format has been changing due to the
early development state of the program. The first schema will be created
after some feedback has been generated with regards to the file format,
and will likely see several revisions before the initial format is
decided.
</dd>
<dt><strong>Buzzword Compatibility</strong></dt>
<dd>
There is a little of this in the choice to use XML as well. If nothing
else, just using XML in a program may get more people to take a look
at what the program does, and hopefully a few people will be interested
enough to want to help improve the overall design of the PythonCAD file
format and the PythonCAD program itself.
</dd>
</dl>
<p>
The format is in its first incarnation, and as such most likely has various
weaknesses, some more apparent than others. While simpler than creating
an entirely new file format, defining a good XML file is an iterative
process. The overall structure of the file is regulated by XML requirements,
but deciding on what to call the tags, what should be attributes, how
things should be arranged, etc., are all left to the designers.
</p>
<p>
A couple of obvious improvements can be made to the format initially. Much
of the following will not be clear unless you&apos;ve spent some time working
with PythonCAD and looked at one of its saved files.
</p>
<ol>
<li>
Don&apos;t save empty tags. They increase the file size slightly, and yet
keep no useful information in the saved file. <strong>[This problem is
addressed in release DS1-R2.]</strong>
</li>
<li>
Only save colors, linetypes, styles, etc. that are actually used in the
drawing. Currently all of the loaded things in the drawing are saved, but
if there is only one or two of each used, only those should be saved.
<strong>[This problem is addressed in release DS1-R4.]</strong>
</li>
<li>
Some of the attribute names are inconsistent. Overriding style attributes
do not have the same names as those in the style - <q>color</q> versus
<q>cid</q>. Dimension color and font bits are also inconsistent, and
the indirect storage of these objects as objects contained in a separate list
instead of directly storing the object itself is confusing.
</li>
<li>
Should some of the attributes become children tags? This seems more like
a question of style, as what is most important is storing the information.
The use of the Python minidom library to format the XML file also creates
difficulties in file storage choices due to the way it formats values
kept between opening and closing tags.
</li>
</ol>
<p>
As development work continues on PythonCAD, the shortcomings in the file
format will be removed as much as possible. At such time as the first
stable release is made, the file format will be frozen for that release.
It is almost a certainty that the file format will need some changes after
that point, so the format will evolve as the application does.
</p>
<h3><a id="tags">File Tags</a></h3>
<p>
Here are the tags used for saving a file. This number of tags will
change as the file format is modified, as will the attributes the
tag may contain. Also, some of the tags represent objects that are
not necessarily fully functional. As development progresses, the
program will eventually fully support all the below objects. Each
object is listed below, with the XML tag given in brackets.
</p>
<h4>Drawing Properties</h4>
<ul>
<li><a href="#color">Colors [&lt;Color&gt;]</a></li>
<li><a href="#linetype">Linetypes [&lt;Linetype&gt;]</a></li>
<li><a href="#style">Styles [&lt;Style&gt;]</a></li>
<li><a href="#fonts">Fonts [&lt;FontFamily&gt;]</a></li>
<li><a href="#units">Units [&lt;Units&gt;]</a></li>
<li><a href="#dimstyle">Dimension Styles [&lt;DimStyle&gt;]</a></li>
<li><a href="#textstyle">Text Styles [&lt;TextStyle&gt;]</a></li>
</ul>
<h4>Drawing Entities</h4>
<ul>
<li><a href="#point">Points [&lt;Point&gt;]</a></li>
<li><a href="#segment">Segments [&lt;Segment&gt;]</a></li>
<li><a href="#circle">Circles [&lt;Circle&gt;]</a></li>
<li><a href="#arc">Arcs [&lt;Arc&gt;]</a></li>
<li><a href="#hcl">Horizontal Construction Line [&lt;HCLine&gt;]</a></li>
<li><a href="#vcl">Vertical Construction Line [&lt;VCLine&gt;]</a></li>
<li><a href="#acl">Angled Construction Line [&lt;ACLine&gt;]</a></li>
<li><a href="#cline">Two-Point Construction Line [&lt;CLine&gt;]</a></li>
<li><a href="#ccirc">Construction Circle [&lt;CCircle&gt;]</a></li>
<li><a href="#fillet">Fillets [&lt;Fillet&gt;]</a></li>
<li><a href="#chamfer">Chamfers [&lt;Chamfer&gt;]</a></li>
<li><a href="#leader">Leaders [&lt;Leader&gt;]</a></li>
<li><a href="#polyline">Polylines [&lt;Polyline&gt;]</a></li>
<li><a href="#textblock">Text Blocks[&lt;TextBlock&gt;]</a></li>
<li><a href="#ldim">Linear Dimensions [&lt;LDim&gt;]</a></li>
<li><a href="#hdim">Horizontal Dimensions [&lt;HDim&gt;]</a></li>
<li><a href="#vdim">Vertical Dimensions [&lt;VDim&gt;]</a></li>
<li><a href="#rdim">Radial Dimensions [&lt;RDim&gt;]</a></li>
<li><a href="#adim">Angular Dimensions [&lt;ADim&gt;]</a></li>
<li><a href="#layer">Layers [&lt;Layer&gt;]</a></li>
</ul>
<p>
When working in a drawing, the active layer in the drawing is where
whatever entities that get created are stored. No layer will have multiple
equivalent copies of any entity, in order to save space in both memory
and file size. What would be the purpose in having a layer will one million
identical instances of a point at (0,0)? The objects stored in a layer
will all have an unique id, but the id is only unique in that layer. Several
different layers can have a Point with an id of 1; but each layer will
never have two points with the same id.
</p>
<div id="dim">
Dimension objects are, so far, the most complex objects in a drawing. A
dimension can refer to objects (points, circles, arc, etc) that are
stored on a layer different from that of the dimension. This complexity
comes with the price of storing more bits of information for each dimension
than other drawing entities. As dimensions are the most complex objects
in a drawing, they are also the least implemented in the code. The display
of horizontal, vertical, linear, radial and angular dimensions all works,
and each dimension type can be stored and retrieved. The interactive
modification of dimensions is still lacking in PythonCAD though. This
shortcoming will be addressed in future releases.
</div>
<h5 id="color"><a href="#tags">Color</a></h5>
<p>
A color is defined in terms of RGB values. Each value is an integral value
between 0 and 255. The &lt;Color&gt; tag is as follows.
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the color.
</li>
<li>
<strong>r</strong>: The red value of the color.
</li>
<li>
<strong>g</strong>: The green value of the color.
</li>
<li>
<strong>b</strong>: The blue value of the color.
</li>
<li>
<strong>color</strong>: The color expressed as a hexidecimal string like <q>#xxxxxx</q>.
</li>
</ul>
<p>
Attributes <q>r</q>, <q>g</q> and <q>b</q> were the original
attributes used to store the color values. Attribute <q>color</q> was
added to show the color in a hexidecimal format as is commonly seen for
colors defined in web pages. At some point in the future the color storage
will probably change from using attributes of the tag to placing the value
as a text string within the tag like &lt;image:Color&gt;<q>#xxxxx</q>&lt;/image:Color&gt;.
</p>
<h5 id="linetype"><a href="#tags">Linetype</a></h5>
<p>
A linetype is used to define a dashed or a solid line. The &lt;Linetype&gt;
tag is as follows.
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the linetype.
</li>
<li>
<strong>name</strong>: The name of the linetype.
</li>
<li>
<strong>pattern</strong>: The dash pattern of the Linetype
</li>
</ul>
<p>
The <q>pattern</q> can be <code>None</code>, thus making
a solid line. Otherwise it must be a Python list defining
the on/off bit pattern for the dashed line. Each item in the
list must be an integral value, and the length of the list must
be an even number.
</p>
<h5 id="style"><a href="#tags">Style</a></h5>
<p>
A style holds references to a particular color, linetype, and line
thickness. The idea behind the style is to predefine a particular
combination for each of these items, and when this combination is
needed, the program will use the values in the style for new objects.
The &lt;Style&gt; tag is as follows.
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the style.
</li>
<li>
<strong>cid</strong>: The color id used in this style.
</li>
<li>
<strong>ltid</strong>: The linetype id used in this style.
</li>
<li>
<strong>name</strong>: The name of the style.
</li>
<li>
<strong>thickness</strong>: The line thickness (for segments, circles, etc) this style defines.
</li>
</ul>
<p>
The values defined in a style can be overridden on a per-object basis, so
a segment using a particular style may have a different color, linetype,
or thickness than what the style defines.
</p>
<h5 id="fonts"><a href="#tags">Font Families</a></h5>
<p>
Each font used in the drawing must have a &lt;FontFamily&gt; tag associated
with it. The tag itself is very compact and listed below.
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the font.
</li>
<li>
<strong>name</strong>: The font family name
</li>
</ul>
<p>
The handling of fonts in a drawing is not robust, and will be an area
in which developer time will eventually be spent. In the actual drawings,
the display of fonts is still in its earliest stages, so there are many
unresolved issues yet to be dealt with before the text display works well.
</p>
<h5 id="units"><a href="#tags">Units</a></h5>
<p>
A drawing must define what the basic length units are for that drawing.
The dimensions can display different units than what this value is set to,
but selecting what units an x/y coordinate pair represent is still
necessary. The &lt;Units&gt; tag has the following attribute:
</p>
<ul>
<li>
<strong>unit</strong>: The basic unit of length for the drawing
</li>
</ul>
<p>
There are several choices for units at the present. It is likely
that one or two of these will be removed and replaced with some
other choice before the first release is made. Millimeters are
the default unit of length. Angular units are degrees, though adding
an additional angular measurement unit is probable at some point.
When an additional angular measurement unit is added, a new tag
defining the default angular dimension will be added.
</p>
<ul>
<li>Millimeters</li>
<li>Micrometers</li>
<li>Meters</li>
<li>Kilometers</li>
<li>Inches</li>
<li>Feet</li>
<li>Yards</li>
<li>Miles</li>
</ul>
<p>
The <q>unit</q> attribute is a text string stating which unit
is the default unit. Prior to developement release seven, the attribute
was an an integer value that corresponds to a list of choices in the
<q>Generic/units.py</q> file. As it is clearer to simply store
a string like <q>inches</q> instead of some integer value, this
tag was changed. The loading of a drawing with the attribute as an
integer is still supported.
</p>
<h5 id="dimstyle"><a href="#tags">Dimension Styles</a></h5>
<p>
Dimension styles are an effort to contain a standard set of values for
dimensioning attributes, such as line color, font size, text placement,
etc. By setting and saving these values in a style, drawings can benefit
from a uniform appearance, and ease the use of the program. Who would want
to set many different values repeatedly when the collection of these values
can be saved off and activated when needed? As dimensions are complex objects
with many different attributes, however, a dimension style is also complex.
Possibly the complexity can be reduced as development advances. The
&lt;DimStyle&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the dimension style.
</li>
<li>
<strong>name</strong>: The dimension style name
</li>
</ul>
<p>
Here is where storing a dimension style is somewhat different from many
other objects in a drawing. The &lt;DimStyle&gt; tag contains &lt;DimOpt&gt;
children tags, and each of those tags holds one part of the dimension style
values. A DimStyle definition is an arbitrary number of these tags, and
the value associated with the tag overrides the default value given in the
table below.
</p>
<p>
As the development of PythonCAD has advanced, the DimStyle class has seen
several modifications. The following table contains the valid options that
can be used to define a DimStyle, the type of value the option represents,
and the default value of the option.
</p>
<table width="80%">
<tr>
<th>Option</th>
<th align="left">Type</th>
<th align="left">Default Value</th>
</tr>
<tr>
<th>DIM_PRIMARY_FONT_FAMILY</th>
<td>String</td>
<td>Sans</td>
</tr>
<tr>
<th>DIM_PRIMARY_FONT_SIZE</th>
<td>Integer</td>
<td>12</td>
</tr>
<tr>
<th>DIM_PRIMARY_FONT_WEIGHT</th>
<td>String</td>
<td>normal</td>
</tr>
<tr>
<th>DIM_PRIMARY_FONT_STYLE</th>
<td>String</td>
<td>normal</td>
</tr>
<tr>
<th>DIM_PRIMARY_FONT_COLOR</th>
<td>String</td>
<td>#ffffff (White)</td>
</tr>
<tr>
<th>DIM_PRIMARY_PREFIX</th>
<td>Unicode String</td>
<td>[Null]</td>
</tr>
<tr>
<th>DIM_PRIMARY_SUFFIX</th>
<td>Unicode String</td>
<td>[Null]</td>
</tr>
<tr>
<th>DIM_PRIMARY_PRECISION</th>
<td>Integer</td>
<td>3</td>
</tr>
<tr>
<th>DIM_PRIMARY_UNITS</th>
<td>String</td>
<td>millimeters</td>
</tr>
<tr>
<th>DIM_PRIMARY_LEADING_ZERO</th>
<td>Boolean</td>
<td>True</td>
</tr>
<tr>
<th>DIM_PRIMARY_TRAILING_DECIMAL</th>
<td>Boolean</td>
<td>True</td>
</tr>
<tr>
<th>DIM_SECONDARY_FONT_FAMILY</th>
<td>String</td>
<td>Sans</td>
</tr>
<tr>
<th>DIM_SECONDARY_FONT_SIZE</th>
<td>Integer</td>
<td>12</td>
</tr>
<tr>
<th>DIM_SECONDARY_FONT_WEIGHT</th>
<td>String</td>
<td>normal</td>
</tr>
<tr>
<th>DIM_SECONDARY_FONT_STYLE</th>
<td>String</td>
<td>normal</td>
</tr>
<tr>
<th>DIM_SECONDARY_FONT_COLOR</th>
<td>String</td>
<td>#ffffff (White)</td>
</tr>
<tr>
<th>DIM_SECONDARY_PREFIX</th>
<td>Unicode string</td>
<td>[Null]</td>
</tr>
<tr>
<th>DIM_SECONDARY_SUFFIX</th>
<td>Unicode string</td>
<td>[Null]</td>
</tr>
<tr>
<th>DIM_SECONDARY_PRECISION</th>
<td>Integer</td>
<td>3</td>
</tr>
<tr>
<th>DIM_SECONDARY_UNITS</th>
<td>String</td>
<td>millimeters</td>
</tr>
<tr>
<th>DIM_SECONDARY_LEADING_ZERO</th>
<td>Boolean</td>
<td>True</td>
</tr>
<tr>
<th>DIM_SECONDARY_TRAILING_DECIMAL</th>
<td>String</td>
<td>True</td>
</tr>
<tr>
<th>DIM_OFFSET</th>
<td>Float</td>
<td>1.0</td>
</tr>
<tr>
<th>DIM_EXTENSION</th>
<td>Float</td>
<td>1.0</td>
</tr>
<tr>
<th>DIM_COLOR</th>
<td>String</td>
<td>#ffa500 (Orange)</td>
</tr>
<tr>
<th>DIM_POSITION</th>
<td>String</td>
<td>split</td>
</tr>
<tr>
<th>DIM_ENDPOINT</th>
<td>String</td>
<td>None</td>
</tr>
<tr>
<th>DIM_ENDPOINT_SIZE</th>
<td>Float</td>
<td>1.0</td>
</tr>
<tr>
<th>DIM_DUAL_MODE</th>
<td>Boolean</td>
<td>False</td>
</tr>
<tr>
<th>RADIAL_DIM_PRIMARY_PREFIX</th>
<td>Unicode string</td>
<td>None</td>
</tr>
<tr>
<th>RADIAL_DIM_PRIMARY_SUFFIX</th>
<td>Unicode string</td>
<td>[Null]</td>
</tr>
<tr>
<th>RADIAL_DIM_SECONDARY_PREFIX</th>
<td>Unicode string</td>
<td>[Null]</td>
</tr>
<tr>
<th>RADIAL_DIM_SECONDARY_SUFFIX</th>
<td>Unicode string</td>
<td>[Null]</td>
</tr>
<tr>
<th>RADIAL_DIM_DIA_MODE</th>
<td>Boolean</td>
<td>False</td>
</tr>
<tr>
<th>ANGULAR_DIM_PRIMARY_PREFIX</th>
<td>Unicode string</td>
<td>[Null]</td>
</tr>
<tr>
<th>ANGULAR_DIM_PRIMARY_SUFFIX</th>
<td>Unicode string</td>
<td>[Null]</td>
</tr>
<tr>
<th>ANGULAR_DIM_SECONDARY_PREFIX</th>
<td>Unicode string</td>
<td>[Null]</td>
</tr>
<tr>
<th>ANGULAR_DIM_SECONDARY_SUFFIX</th>
<td>Unicode string</td>
<td>[Null]</td>
</tr>
</table>
<p>
Here are the attributes for a &lt;DimOpt&gt; tag.
</p>
<ul>
<li>
<strong>opt</strong>: The name of the dimension option.
</li>
<li>
<strong>value</strong>: The value of the dimension option.
</li>
</ul>
<p>
As stated above, a DimStyle object is composed of any number of the
entities in the list above. The DimStyle will use the default value
if one is not provided in the list of options used to set the DimStyle
when it is created.
</p>
<p>
For dimension options that specify colors or fonts, there isn&apos;t a
<q>value</q> attribute; instead there is either <q>cid</q> which
represents a color id value, or <q>fid</q>, which holds a font id.
In the long term these different attributes may be removed, and the standard
<q>value</q> attribute used for all &lt;DimOpt&gt; tags.
</p>
<h5 id="textstyle"><a href="#tags">Text Styles</a></h5>
<p>
Text styles are similar to dimension styles in that they contain a set
of common values for displaying text. By storing attributes like font
family name, font size, font weight, font style, and color as a single
object, any block of text that wants to share these attributes can 
reference the text style, and by sharing the common attribute set, memory
requirements are reduced and saved file size can be reduced by removing
redundant copies of identical values.
</p>
<p>
The manipulation of text in PythonCAD is very new, so it is almost
guaranteed that the fields comprising a TextStyle entity will change
in future release. As this entity changes, efforts will be made to ensure
that the text styles saved in older versions of the entity will be
read in the newer version. It is unlikely that the saving of new
style entities in a manner that older PythonCAD releases will be able
to use will happen, at least until the first official release is made.
The &lt;TextStyle&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the textstyle.
</li>
<li>
<strong>name</strong>: The dimension style name
</li>
<li>
<strong>cid</strong>: The id of the color used in this textstyle.
</li>
<li>
<strong>fid</strong>: The id of the font family used in this textstyle.
</li>
<li>
<strong>size</strong>: The font size of the textstyle.
</li>
<li>
<strong>style</strong>: The font style of the textstyle.
</li>
<li>
<strong>weight</strong>: The font weight of the textstyle.
</li>
</ul>
<p>
The sixth development release of PythonCAD stored the <q>weight</q> and
<q>style</q> attributes as integer values, but it became clear quickly
that doing so was needlessly confusing. With development release seven, these
attributes are stored as text strings. It is so much simpler to understand
an attribute when the value is a string like <q>bold</q> or
<q>italic</q> than some number. Until the text handling features in
PythonCAD become stable, it is very likely that changes of this nature
between one release and another will be made.
</p>
<h5 id="point"><a href="#tags">Points</a></h5>
<p>
This tag stores the data for a 2-D point. The &lt;Point&gt; tag has the
following attributes.
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the point.
</li>
<li>
<strong>x</strong>: The x-coordinate of the point.
</li>
<li>
<strong>y</strong>: The y-coordinate of the point.
</li>
</ul>
<h5 id="segment"><a href="#tags">Segments</a></h5>
<p>
This tag stores the data for a 2-D line segment. The &lt;Segment&gt; tag has
the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the segment.
</li>
<li>
<strong>p1</strong>: The point id for the first endpoint of the segment.
</li>
<li>
<strong>p2</strong>: The point id for the second endpoint of the segment.
</li>
<li>
<strong>style</strong>: The style id for the segment.
</li>
</ul>
<p>
Any overridden style attribute will be present as an attribute in the segment.
</p>
<h5 id="circle"><a href="#tags">Circles</a></h5>
<p>
A &lt;Circle&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the circle.
</li>
<li>
<strong>cp</strong>: The point id for the center point of the circle.
</li>
<li>
<strong>r</strong>: The circle&apos;s radius.
</li>
<li>
<strong>style</strong>: The style id for the circle.
</li>
</ul>
<p>
Any overridden style attribute will be present as an attribute in
the circle.
</p>
<h5 id="arc"><a href="#tags">Arcs</a></h5>
<p>
An &lt;Arc&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the arc.
</li>
<li>
<strong>cp</strong>: The point id for the center point of the arc.
</li>
<li>
<strong>r</strong>: The arc&apos;s radius.
</li>
<li>
<strong>sa</strong>: The starting angle of the arc.
</li>
<li>
<strong>ea</strong>: The ending angle of the arc.
</li>
<li>
<strong>style</strong>: The style id for the arc.
</li>
</ul>
<p>
The start angle and end angle of an arc are given in degrees, and
will be a value between 0.0 and 360.0. All arcs are defined in
a counter-clockwise manner, so an arc with a start angle of 0.0
and an end angle of 45.0 is a 45.0 degree arc. If the start angle
is 45.0, and the end angle is 0.0, then the arc is a 315.0 degree
arc.
</p>
<p>
Any overridden style attribute will be present as an attribute in
the arc.
</p>
<h5 id="hcl"><a href="#tags">Horizontal Construction Lines</a></h5>
<p>
A horizontal construction line represents an infinitely long line horizontal
through some point. Construction lines will not be shown on printed
output. A &lt;HCLine&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the horizontal construction line.
</li>
<li>
<strong>location</strong>: The point id for the point through which the line passes.
</li>
</ul>
<p>
The appearance of a construction line is not overrideable. All construction lines and circles have the same color, linetype, and thickness.
</p>
<h5 id="vcl"><a href="#tags">Vertical Construction Lines</a></h5>
<p>
A vertical construction line represents an infinitely long line vertical
through some point. Construction lines will not be shown on printed
output. A &lt;VCLine&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the vertical construction line.
</li>
<li>
<strong>location</strong>: The point id for the point through which the line passes.
</li>
</ul>
<p>
The appearance of a construction line is not overrideable. All construction lines and circles have the same color, linetype, and thickness.
</p>
<h5 id="acl"><a href="#tags">Angled Construction Lines</a></h5>
<p>
An angled construction line represents an infinitely long line passing
through some point and at a user-defined angle. Construction lines will
not be shown on printed output. A &lt;ACLine&gt; tag has the following
attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the angled construction line.
</li>
<li>
<strong>location</strong>: The point id for the point through which the line passes.
</li>
<li>
<strong>angle</strong>: The angle at which the construction line lies.
</li>
</ul>
<p>
The angle for an angled construction lines is defined in degrees, and will
be a value between -90.0 and 90.0. An angled construction line having
a value of -90.0 or 90.0 is the same as a vertical construction line, and
one with an angle of 0.0 is essentially a horizontal construction line.
</p>
<p>
The appearance of a construction line is not overrideable. All construction lines and circles have the same color, linetype, and thickness.
</p>
<h5 id="cline"><a href="#tags">Two-point Construction Lines</a></h5>
<p>
An two-point construction line represents an infinitely long line passing
through two distinct points. Construction lines will not be shown on printed
output. A &lt;CLine&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the two-point construction line.
</li>
<li>
<strong>p1</strong>: The point id of the first key-point of the construction line.
</li>
<li>
<strong>p2</strong>: The point id of the second key-point of the construction line.
</li>
</ul>
<p>
The two points of the construction line must be different. If both points
have equal x-coordinate values, then the two-point construction line is
the same as a vertical construction line. Likewise, if both points have
equal y-coordinate values, the construction line is the same as a horizontal
construction line.
</p>
<p>
The appearance of a construction line is not overrideable. All construction lines and circles have the same color, linetype, and thickness.
</p>
<h5 id="ccirc"><a href="#tags">Construction Circles</a></h5>
<p>
A construction circle is essentially the same as a standard circle, except
as it is a construction entity, it will not be shown on printed output. A
&lt;CCircle&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the construction circle.
</li>
<li>
<strong>cp</strong>: The point id of the construction circle center point.
</li>
<li>
<strong>r</strong>: The construction circle radius.
</li>
</ul>
<p>
The appearance of a construction line is not overrideable. All construction lines and circles have the same color, linetype, and thickness.
</p>
<h5 id="fillet"><a href="#tags">Fillets</a></h5>
<p>
A fillet is a smooth, round joint between two segments. At the present,
only segments can be connected with a fillet, though at some point joining
arc is planned. A &lt;Fillet&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the fillet.
</li>
<li>
<strong>radius</strong>: The radius of the fillet.
</li>
<li>
<strong>s1</strong>: The first segment the fillet connects to.
</li>
<li>
<strong>s2</strong>: The second segment the fillet connects to.
</li>
<li>
<strong>style</strong>: The style id for the fillet.
</li>
</ul>
<h5 id="chamfer"><a href="#tags">Chamfers</a></h5>
<p>
A chamfer is a straight connection between two segments. Like a fillet,
a chamfer can only join segments. This will probably not change in future
releases. A &lt;Chamfer&gt; tag has the following attributes.
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the chamfer.
</li>
<li>
<strong>length</strong>: The length of the chamfer.
</li>
<li>
<strong>s1</strong>: The first segment the fillet connects to.
</li>
<li>
<strong>s2</strong>: The second segment the fillet connects to.
</li>
<li>
<strong>style</strong>: The style id for the fillet.
</li>
</ul>
<p>
The chamfer length is the distance subtracted from the original segment
length at the endpoint where the chamfer is placed. It does not represent
the distance between the two segment endpoints where the chamfer is drawn.
</p>
<h5 id="leader"><a href="#tags">Leaders</a></h5>
<p>
This tag stores the data for a leader line. A leader line is typically
used to act as a visual pointer in a drawing. The &lt;Leader&gt; tag has
the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the leader.
</li>
<li>
<strong>p1</strong>: The point id for the first endpoint of the leader.
</li>
<li>
<strong>p2</strong>: The point id for the second endpoint of the leader.
</li>
<li>
<strong>p3</strong>: The point id for the final endpoint of the leader.
</li>
<li>
<strong>style</strong>: The style id for the leader.
</li>
<li>
<strong>size</strong>: The size of the leader arrow pointer.
</li>
</ul>
<p>
Any overridden style attribute will be present as an attribute in the leader.
</p>
<h5 id="polyline"><a href="#tags">Polylines</a></h5>
<p>
This tag defines the storage of Polylines. A Polyline is essentially
a connected set of segments. There is no limit to the length of the
polyline. The Polyline object was added to PythonCAD in an effort to
provide an similar entity to other CAD programs that have an drawing
entity like this. As such the fields comprising an Polyline may change
to provide additional functionality or simpler conversion to/from the
behavior of this type of object in other CAD programs. The &lt;Polyline&gt;
tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the polyline.
</li>
<li>
<strong>points</strong>: A list of point references that define the
vertices of the polyline.
</li>
<li>
<strong>style</strong>: The style id for the polyline.
</li>
</ul>
<p>
The <q>points</q> attribute is a Python list, similar to that used
to store <a href="#linetype">linetype</a> entities. The list must hold at
least two references to point objects stored in the layer.
</p>
<p>
Any overridden style attribute will be present as an attribute in the leader.
</p>
<h5 id="textblock"><a href="#tags">TextBlocks</a></h5>
<p>
The TextBlock tag stores the text strings in the file. Expect the TextBlock
tag to change somewhat until the first official release as text handling
within PythonCAD improves. The &lt;TextBlock&gt; tag currently has the
following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the textblock.
</li>
<li>
<strong>tsid</strong>: A reference to the TextStyle used by the textblock.
</li>
<li>
<strong>angle</strong>: The angle of the textblock.
</li>
<li>
<strong>x</strong>: The x-coordinate where the textblock should be placed.
</li>
<li>
<strong>y</strong>: The y-coordinate where the textblock should be placed.
</li>
</ul>
<p>
The <q>angle</q> attribute is currently ignored, as PythonCAD does not
yet have the ability to display rotated text. There is also a current
implicit assumption that all text is left justified, so the <q>x</q> and
<q>y</q> attributes give the upper left-hand coordinate where the
text begins. An attribute storing text justification will be added to
provide for the storage of center or right justified text, and other
attributes will be added as the handling of text in PythonCAD becomes more
complete. As text in PythonCAD is stored as Unicode objects, attributes
that indicate the text as right-to-left text or multibyte characters may
be added as well.
</p>
<p>
The storage of the text itself is handled in child entities of a TextBlock
entity. The initial layout of these child entities was arrived at after
failing to resolve a problem in the Python minidom library with the storage
of TextNodes. See the comments in the <q>Generic/imageio.py</q> for
a short description of the problem. If there is a solution to the problem
described in this note please send it to the PythonCAD developer.
</p>
<p>
Each line of text is stored in a &lt;TextLine&gt; entity. This entity
is defined with a single attribute <q>text</q> that stores the
text for the line. There should be a &lt;TextLine&gt; entity for every
line of text in the textblock, even empty lines. Once the minidom problem
is resolved, the text string will be stored as a TextNode child of the
&lt;TextLine&gt;, not as an attribute.
</p>
<h5 id="ldim"><a href="#tags">Linear Dimensions</a></h5>
<p>
A linear dimension measures the absolute distance between two separate
points. The code for storing linear dimensions works, but the code
for drawing them has not been completed, so these dimensional entities
will not be displayed. A &lt;LDim&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the linear dimension.
</li>
<li>
<strong>ds</strong>: The dimension style identifier used by the linear dimension.
</li>
<li>
<strong>l1</strong>: The layer identifier containing the first point of the linear dimension.
</li>
<li>
<strong>p1</strong>: The point identifier for the first point of the linear dimension.
</li>
<li>
<strong>l2</strong>: The layer identifier containing the second point of the linear dimension.
</li>
<li>
<strong>p2</strong>: The point identifier for the second point of the linear dimension.
</li>
<li>
<strong>x</strong>: The x-coordinate around which the dimension text should be centered.
</li>
<li>
<strong>y</strong>: The y-coordinate around which the dimension text should be centered.
</li>
</ul>
<p>
Please refer to the brief discussion about dimension objects <a href="#dim">here</a>.
</p>
<h5 id="hdim"><a href="#tags">Horizontal Dimensions</a></h5>
<p>
A horizontal dimension measures the horizontal distance between two separate
points. The code for storing horizontal dimensions works, as well as the
code for drawing them. The code is not very robust, however, so it is quite
easy to create a horizontal dimension that is drawn oddly. Future releases
will address these shortcomings. A &lt;HDim&gt; tag has the following
attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the horizontal dimension.
</li>
<li>
<strong>ds</strong>: The dimension style identifier used by the horizontal dimension.
</li>
<li>
<strong>l1</strong>: The layer identifier containing the first point of the horizontal dimension.
</li>
<li>
<strong>p1</strong>: The point identifier for the first point of the horizontal dimension.
</li>
<li>
<strong>l2</strong>: The layer identifier containing the second point of the horizontal dimension.
</li>
<li>
<strong>p2</strong>: The point identifier for the second point of the horizontal dimension.
</li>
<li>
<strong>x</strong>: The x-coordinate around which the dimension text should be centered.
</li>
<li>
<strong>y</strong>: The y-coordinate around which the dimension text should be centered.
</li>
</ul>
<p>
Please refer to the brief discussion about dimension objects <a href="#dim">here</a>.
</p>
<h5 id="vdim"><a href="#tags">Vertical Dimensions</a></h5>
<p>
A vertical dimension measures the vertical distance between two separate
points. The code for storing vertical dimensions works, as well as the
code for drawing them. The code is not very robust, however, so it is quite
easy to create a vertical dimension that is drawn oddly. Future releases
will address these shortcomings. A &lt;VDim&gt; tag has the following
attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the vertical dimension.
</li>
<li>
<strong>ds</strong>: The dimension style identifier used by the vertical dimension.
</li>
<li>
<strong>l1</strong>: The layer identifier containing the first point of the vertical dimension.
</li>
<li>
<strong>p1</strong>: The point identifier for the first point of the vertical dimension.
</li>
<li>
<strong>l2</strong>: The layer identifier containing the second point of the vertical dimension.
</li>
<li>
<strong>p2</strong>: The point identifier for the second point of the vertical dimension.
</li>
<li>
<strong>x</strong>: The x-coordinate around which the dimension text should be centered.
</li>
<li>
<strong>y</strong>: The y-coordinate around which the dimension text should be centered.
</li>
</ul>
<p>
Please refer to the brief discussion about dimension objects <a href="#dim">here</a>.
</p>
<h5 id="rdim"><a href="#tags">Radial Dimensions</a></h5>
<p>
A radial dimension measures only circles and arcs. The dimension can be
set to measure diameters as well. The code to create and display radial
dimension is in place, though the drawing code is in the earliest stages.
A &lt;RDim&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the radial dimension.
</li>
<li>
<strong>ds</strong>: The dimension style identifier used by the radial dimension.
</li>
<li>
<strong>l</strong>: The layer identifier containing the measured circle or arc
</li>
<li>
<strong>c</strong>: The measured circle or arc identifier.
</li>
<li>
<strong>x</strong>: The x-coordinate around which the dimension text should be centered.
</li>
<li>
<strong>y</strong>: The y-coordinate around which the dimension text should be centered.
</li>
</ul>
<p>
Please refer to the brief discussion about dimension objects <a href="#dim">here</a>.
</p>
<h5 id="adim"><a href="#tags">Angular Dimensions</a></h5>
<p>
An angular dimension measures some angle defined by three distinct points.
If measuring an arc, the vertex point is the center point of the arc, and
the other two points are the arc endpoints. There is essentially no code
written for the drawing of an angular dimension, and only the barest code
written for the creation of one. For the first release, and probably for
the next few development releases, angular dimensions will not work.
A &lt;ADim&gt; tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the angular dimension.
</li>
<li>
<strong>ds</strong>: The dimension style identifier used by the angular dimension.
</li>
<li>
<strong>l1</strong>: The layer identifier containing the vertex point of the vertical dimension.
</li>
<li>
<strong>p1</strong>: The point identifier for the vertex point of the angular dimension.
</li>
<li>
<strong>l2</strong>: The layer identifier containing the first endpoint of the angular dimension.
</li>
<li>
<strong>p2</strong>: The point identifier for the first endpoint of the angular dimension.
</li>
<li>
<strong>l3</strong>: The layer identifier containing the second endpoint of the angular dimension.
</li>
<li>
<strong>p3</strong>: The point identifier for the second endpoint of the angular dimension.
</li>
<li>
<strong>x</strong>: The x-coordinate around which the dimension text should be centered.
</li>
<li>
<strong>y</strong>: The y-coordinate around which the dimension text should be centered.
</li>
</ul>
<p>
Please refer to the brief discussion about dimension objects <a href="#dim">here</a>.
</p>
<h5 id="layer"><a href="#tags">Layers</a></h5>
<p>
Layers are the containers for all the drawing entities. A drawing consists of
at least one layer, with an unlimited number of children layers below the
top-most parent layer. Except for the top layer, any layer can be moved from
one parent to another. All layers can be hidden or displayed, and any layer
with children layers can hide all its children, as well as display them all.
The organization of the layers in a drawing is shown on the left-hand side
of the interface. Presently this display allows for easy layer renaming,
creation of children layers, and the hiding or displaying of each layer.
Re-parenting a layer via drag-and-drop does not work yet. A &lt;Layer&gt;
tag has the following attributes:
</p>
<ul>
<li>
<strong>id</strong>: The unique identifier for the layer.
</li>
<li>
<strong>name</strong>: The name of the layer.
</li>
<li>
<strong>scale</strong>: The scale factor to use for dimensioning entities contained in that layer.
</li>
</ul>
<p>
Every layer in a drawing can have the same name, though that would be
incredibly confusing. The scale factor is not used yet, as the code
for dimensioning is in such an early state. It is believed that the
ability to set different scale factors for different layers is a desirable
feature, though this may end up not being the case.
</p>
<p>
When a layer is saved, the entities stored in that layer are saved
as children tags of the layer. More correctly they are grand-children,
as each entity type is stored below a tag indicating what sort of things
are being grouped together. So, a set of &lt;Point&gt; objects will be
stored as children of a &lt;Points&gt; tag, &lt;Segment&gt; tags will
be within &lt;Segments&gt;, etc.
</p>
<h4>Missing Entities</h4>
<p>
A quick glance over the above defined entities will make the astute reader
ask about hatching and other entities that any serious CAD package should
offer. The short answer is these features are not available yet. The first
development release of the program concentrated on getting the basic drawing
code working, providing a few dimensioning abilities, and the initial
implementation of a user interface. Each following release has added new
entities and improved the functionality of the existing entities, and
future releases will hopefully continue the trend. PythonCAD will not have
an official release until, at the very least, hatching and printing functions
are implemented.
</p>
</div><!-- main_content-->
<div id="footer">
<h3>Site Hosting Information</h3>
<div id="hwm">
The PythonCAD website is hosted by <a href="http://www.hwm-usa.com/">Hughes Web Marketing</a>.
</div><!-- hwm -->
<div id="w3c">
This page is <a href="http://validator.w3.org/check/referer">Valid XHTML 1.0</a>.
</div><!-- w3c -->
</div><!-- footer -->
</body>
</html>
